package org.ioc.commons.impl.gwt.client.globalflowcontroller;

import org.ioc.commons.flowcontrol.actioncontroller.IsExternalAction;
import org.ioc.commons.flowcontrol.common.BindRegistration;
import org.ioc.commons.flowcontrol.eventbus.IsEvent;
import org.ioc.commons.flowcontrol.globalflowcontroller.GlobalFlowController;
import org.ioc.commons.flowcontrol.operationmanager.IsOperation;
import org.ioc.commons.ui.IsWidget;

import com.google.gwt.event.logical.shared.AttachEvent;
import com.google.gwt.user.client.ui.Widget;

public class GwtGlobalFlowController<E extends Enum<? extends IsEvent>, O extends Enum<? extends IsOperation>, A extends Enum<? extends IsExternalAction>>
		implements GlobalFlowController<E, O, A> {

	protected final GwtGlobalEventBusImpl<E> eventbus;
	protected final GwtGlobalOperationManagerImpl<O> operationManager;
	protected final GwtGlobalActionControllerImpl<A> actionController;

	public GwtGlobalFlowController(com.google.web.bindery.event.shared.EventBus eventBus) {
		this.eventbus = new GwtGlobalEventBusImpl<E>(eventBus);
		this.operationManager = new GwtGlobalOperationManagerImpl<O>(eventBus);
		this.actionController = new GwtGlobalActionControllerImpl<A>(eventBus);
	}

	final public GlobalEventBus<E> eventBus() {
		return this.eventbus;
	}

	final public GlobalOperationManager<O> operationManager() {
		return this.operationManager;
	}

	final public GlobalActionController<A> actionController() {
		return this.actionController;
	}

	static void unbindWhenDetach(final BindRegistration registration, IsWidget display) {
		Widget w = (Widget) display.asWidget();

		w.addAttachHandler(new AttachEvent.Handler() {

			@Override
			public void onAttachOrDetach(AttachEvent event) {
				if (!event.isAttached()) {
					registration.unbind();
				}
			}
		});
	}

}
