package org.ioc.commons.impl.gwt.client.globalflowcontroller;

import org.ioc.commons.flowcontrol.common.BindRegistration;
import org.ioc.commons.flowcontrol.globalflowcontroller.GlobalFlowController.GlobalOperationManager;
import org.ioc.commons.flowcontrol.operationmanager.IsOperation;
import org.ioc.commons.flowcontrol.operationmanager.OperationHandler;
import org.ioc.commons.impl.gwt.client.flowcontrol.operationmanager.GwtOperationManagerImpl;
import org.ioc.commons.ui.IsWidget;

import com.google.web.bindery.event.shared.EventBus;

class GwtGlobalOperationManagerImpl<O extends Enum<? extends IsOperation>> extends GwtOperationManagerImpl<O> implements GlobalOperationManager<O> {

	public GwtGlobalOperationManagerImpl(EventBus eventBus) {
		super(eventBus);
		// Nada
	}

	@Override
	public BindRegistration bindOperation(IsWidget whileDisplayIsActive, O operation, OperationHandler<O> handler) {
		BindRegistration registration = this.bindOperation(operation, handler);
		
		GwtGlobalFlowController.unbindWhenDetach(registration, whileDisplayIsActive);
		return registration;
	}

	@Override
	public BindRegistration bindOperationOnce(IsWidget whileDisplayIsActive, O operation, OperationHandler<O> handler) {
		BindRegistration registration = this.bindOperationOnce(operation, handler);
		
		GwtGlobalFlowController.unbindWhenDetach(registration, whileDisplayIsActive);
		return registration;
	}

	@Override
	public BindRegistration bindOperationsRunning(IsWidget whileDisplayIsActive, OperationHandler<O> handler) {
		BindRegistration registration = this.bindOperationsRunning(handler);
		
		GwtGlobalFlowController.unbindWhenDetach(registration, whileDisplayIsActive);
		return registration;
	}

}
