package org.ioc.commons.impl.gwt.integration.client.dataaccess.requestfactory.rebind.internal;

import java.util.Set;

import javax.validation.ConstraintViolation;

import org.ioc.commons.integration.dataaccess.dao.DaoReceiver;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.web.bindery.requestfactory.shared.Receiver;
import com.google.web.bindery.requestfactory.shared.ServerFailure;

public class RFDaoReceiver<V> extends Receiver<V> implements AsyncCallback<V>, DaoReceiver<V> {

	private DaoReceiver<V> wrapped;

	public RFDaoReceiver() {
		// Nada
	}

	public RFDaoReceiver(DaoReceiver<V> wrapped) {
		this.wrapped = wrapped;
	}

	@Override
	final public void onSuccess(V response) {
		onEnd(true);
		success(response);
	}

	@Override
	final public void onFailure(ServerFailure error) {
		onEnd(false);
		failure(error);
	}

	@Override
	final public void onFailure(Throwable caught) {
		onEnd(false);
		failure(caught);
	}

	@Override
	final public void onConstraintViolation(Set<ConstraintViolation<?>> violations) {
		onEnd(false);
		constraintViolation(violations);
	}

	@Override
	public void onEnd(boolean success) {
		if (this.wrapped != null) {
			this.wrapped.onEnd(success);
		}
	}

	@Override
	public void success(V response) {
		if (this.wrapped != null) {
			this.wrapped.success(response);
		}
	}

	public void failure(ServerFailure error) {
		org.ioc.commons.integration.dataaccess.dao.ServerFailure customServerFailure = new org.ioc.commons.integration.dataaccess.dao.ServerFailure(error.getMessage(),
				error.getStackTraceString(), error.getExceptionType(), error.isFatal());
		this.failure(customServerFailure);
	}

	@Override
	public void failure(Throwable caught) {
		if (this.wrapped != null) {
			this.wrapped.failure(caught);
		}
	}

	@Override
	public void constraintViolation(Set<ConstraintViolation<?>> violations) {
		if (this.wrapped != null) {
			this.wrapped.constraintViolation(violations);
		}
	}

	@Override
	public void failure(org.ioc.commons.integration.dataaccess.dao.ServerFailure serverFailure) {
		if (this.wrapped != null) {
			this.wrapped.failure(serverFailure);
		}
	}
}
