package org.ioc.commons.impl.gwt.integration.client.service.rpc.rebind.internal;

import org.ioc.commons.flowcontrol.operationmanager.IsOperation;
import org.ioc.commons.impl.gwt.integration.client.service.rpc.rebind.internal.RpcServiceOperationManagerWrapper.OperationTrigger;
import org.ioc.commons.integration.service.Service;
import org.ioc.commons.integration.service.ServiceCallback;

import com.google.gwt.user.client.rpc.ServiceDefTarget;

public abstract class RpcBaseService<R> implements Service {

	protected R rpc;

	public RpcBaseService(R rpc) {
		this.rpc = rpc;
	}

	public ServiceDefTarget getServiceDefTarget() {
		return (ServiceDefTarget) rpc;
	}

	@Override
	public String getUrlService() {
		ServiceDefTarget sdt = this.getServiceDefTarget();
		return sdt.getServiceEntryPoint();
	}

	protected <T> void handleSuccess(ServiceCallback<T> callback, T result,
			OperationTrigger<? extends Enum<? extends IsOperation>> operaTrigger) {
		if (operaTrigger != null) {
			operaTrigger.operationFinished(true);
		}
		callback.onSuccess(result);
	}

	protected <T> void handleFail(ServiceCallback<T> callback, Throwable e,
			OperationTrigger<? extends Enum<? extends IsOperation>> operaTrigger) {
		if (operaTrigger != null) {
			operaTrigger.operationFinished(false);
		}
		callback.onFailure(e);
	}
}
