package org.ioc.commons.impl.gwt.shared.common.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class WrappedListAsSet<E> implements Set<E> {

	private List<E> wrappedList;

	public WrappedListAsSet(List<E> wrappedList) {
		this.wrappedList = wrappedList;
	}

	@Override
	public int size() {
		return this.wrappedList.size();
	}

	@Override
	public boolean isEmpty() {
		return this.wrappedList.isEmpty();
	}

	@Override
	public boolean contains(Object o) {
		return this.wrappedList.contains(o);
	}

	@Override
	public Iterator<E> iterator() {
		return this.wrappedList.iterator();
	}

	@Override
	public Object[] toArray() {
		return this.wrappedList.toArray();
	}

	@Override
	public <T> T[] toArray(T[] a) {
		return this.wrappedList.toArray(a);
	}

	@Override
	public boolean add(E e) {
		if (this.wrappedList.contains(e)) {
			return false;
		}

		return this.wrappedList.add(e);
	}

	@Override
	public boolean remove(Object o) {
		return this.wrappedList.remove(o);
	}

	@Override
	public boolean containsAll(Collection<?> c) {
		return this.wrappedList.containsAll(c);
	}

	@Override
	public boolean addAll(Collection<? extends E> c) {
		Collection<? extends E> news = new ArrayList<E>(c);
		news.removeAll(wrappedList);
		return this.wrappedList.addAll(news);
	}

	@Override
	public boolean retainAll(Collection<?> c) {
		return this.wrappedList.retainAll(c);
	}

	@Override
	public boolean removeAll(Collection<?> c) {
		return this.wrappedList.removeAll(c);
	}

	@Override
	public void clear() {
		this.wrappedList.clear();
	}

	public List<E> getWrappedList() {
		return this.wrappedList;
	}
}
