package org.ioc.commons.impl.gwt.shared.common.util;

import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

import com.google.gwt.view.client.SetSelectionModel;

public class WrappedSelectionModelAsSet<E> implements Set<E> {

	private SetSelectionModel<E> selectionModel;

	public WrappedSelectionModelAsSet(SetSelectionModel<E> selectionModel) {
		this.selectionModel = selectionModel;
	}

	@Override
	public int size() {
		return this.selectionModel.getSelectedSet().size();
	}

	@Override
	public boolean isEmpty() {
		return this.selectionModel.getSelectedSet().isEmpty();
	}

	@Override
	public boolean contains(Object o) {
		return this.selectionModel.getSelectedSet().contains(o);
	}

	@Override
	public Iterator<E> iterator() {
		return this.selectionModel.getSelectedSet().iterator();
	}

	@Override
	public Object[] toArray() {
		return this.selectionModel.getSelectedSet().toArray();
	}

	@Override
	public <T> T[] toArray(T[] a) {
		return this.selectionModel.getSelectedSet().toArray(a);
	}

	@Override
	public boolean add(E e) {
		this.selectionModel.setSelected(e, true);
		return true;
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean remove(Object o) {
		this.selectionModel.setSelected((E) o, false);
		return true;
	}

	@Override
	public boolean containsAll(Collection<?> c) {
		return this.selectionModel.getSelectedSet().containsAll(c);
	}

	@Override
	public boolean addAll(Collection<? extends E> c) {
		for (E e : c) {
			this.selectionModel.setSelected(e, true);
		}
		return true;
	}

	@Override
	public boolean retainAll(Collection<?> c) {
		Set<E> selectedSet = this.selectionModel.getSelectedSet();
		for (E e : selectedSet) {
			this.selectionModel.setSelected(e, c.contains(e));
		}
		return true;
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean removeAll(Collection<?> c) {
		for (Object o : c) {
			this.selectionModel.setSelected((E) o, false);
		}
		return true;
	}

	@Override
	public void clear() {
		this.selectionModel.clear();
	}
	
	public SetSelectionModel<E> getWrappedSelectionModel() {
		return selectionModel;
	}
}
