package org.ioc.commons.impl.gwt.shared.common.util;

import java.util.Observable;
import java.util.Observer;

import com.google.gwt.core.client.Scheduler;
import com.google.gwt.core.client.Scheduler.ScheduledCommand;
import com.google.gwt.user.client.ui.ValueListBox;

public class WrappedValueListBoxAsList<T> extends ObservableArrayList<T> implements Observer {

	private ValueListBox<T> valueListBoxWidget;
	protected boolean pendingUpdate;

	public WrappedValueListBoxAsList(ValueListBox<T> valueListBoxWidget) {
		this.valueListBoxWidget = valueListBoxWidget;
		this.addObserver(this);
	}

	@Override
	public void update(Observable o, Object arg) {
		if (!this.pendingUpdate) {
			this.pendingUpdate = true;
			Scheduler.get().scheduleFinally(new ScheduledCommand() {

				@Override
				public void execute() {
					WrappedValueListBoxAsList.this.pendingUpdate = false;
					valueListBoxWidget.setAcceptableValues(WrappedValueListBoxAsList.this);
				}
			});
		}
	}
}
